*+
*+
*+    Source Module => D:\SRC\WILDSEEK\TOKEN.PRG
*+
*+    Author, Phil Barnett
*+    
*+    This program is released to Public Domain by the author, Sept 8, 1999.
*+
*+    Functions: Function numtoken()
*+               Function token()
*+
*+    Reformatted by Click! 2.03 on Sep-8-1999 at  3:02 am
*+
*+

#include "COMMON.CH"

/*
*+
*+
*+    Function test()
*+
*+
*+
function test()

local x
local nHowMany       := numtoken( '  This    is   a  test,   eh?  ', ' ' )

? nHowMany

for x := 1 to nHowMany
   ? '<' + token( '  This    is   a  test,   eh?  ', ' ', x ) + '>'
next

? numtoken( '             ', ' ' )

? numtoken( '', ' ' )

return nil
*/

*+
*+
*+    Function numtoken()
*+
*+    Called from ( wildseek.prg )   1 - function wildadd()
*+
*+
*+
function numtoken( cString, cDelimiter )

// This is used to get a count of how many tokens are in a string based
// on the supplied delimiter. This defaults to the same delimiters as
// used in the like named function in Clipper Tools III, so it should
// work identically.

// PLEASE NOTE. If you have Clipper Tools, it is good to use it.
// It is written in ASM, and is much fastet than this Clipper coded routine.
// The function is identical.

local x
local nStrLen    := len( cString )
local nHowMany   := 0
local lFoundWord := .f.
local retval     := 0

default cDelimiter to ' ,.;:!?/\<>()^#&%+-*' + chr( 0 ) + chr( 9 ) + ;
        chr( 10 ) + chr( 13 ) + ;
        chr( 26 ) + chr( 138 ) + ;
        chr( 141 )

for x := 1 to nStrLen
   if substr( cString, x, 1 ) $ cDelimiter
      if lFoundWord
         nHowMany ++
      endif
      do while x < nStrLen .and. substr( cString, x + 1, 1 ) $ cDelimiter
         x ++
      enddo
   else
      lFoundWord := .t.
   endif
next

if nStrLen > 0
   retval := iif( right( cString, 1 ) $ cDelimiter, nHowmany, nHowMany + 1 )
endif

return retval

*+
*+
*+    Function token()
*+
*+    Called from ( wildseek.prg )   1 - function wildadd()
*+
*+
*+
function token( cString, cDelimiter, nPointer )

// This is used to extract each token from the string based on the
// delimiter and the numeric pointer which tells us which token to
// return.

// This defaults to the same delimiters as used in the like named
// function in Clipper Tools III, so it should work identically.

local x
local nStrLen      := len( cString )
local nHowMany     := 0
local nLastPointer := 0
local cPart
local lFoundWord   := .f.

default cDelimiter to ' ,.;:!?/\<>()^#&%+-*' + chr( 0 ) + chr( 9 ) + ;
        chr( 10 ) + chr( 13 ) + ;
        chr( 26 ) + chr( 138 ) + ;
        chr( 141 )

for x := 1 to nStrLen
   if substr( cString, x, 1 ) $ cDelimiter
      if lFoundWord
         nHowMany ++
      endif
      if nHowMany == nPointer
         exit
      endif
      do while x < nStrLen .and. substr( cString, x + 1, 1 ) $ cDelimiter
         x ++
      enddo
      nLastPointer := x
   else
      lFoundWord := .t.
   endif
next

// went all the way without nHowmany == nPointer
if x == nStrLen + 1
   // take the last word
   cPart := substr( cString, nLastPointer + 1 )
else
   cPart := substr( cString, nLastPointer + 1, ( x - nLastPointer ) - 1 )
endif

return cPart

*+ EOF: TOKEN.PRG
