*+
*+
*+    Source Module => D:\SRC\WILDSEEK\WILDSEEK.PRG
*+
*+    Author, Phil Barnett
*+    
*+    This program is released to Public Domain by the author, Sept 8, 1999.
*+
*+    Functions: Procedure Test()
*+               Function WildInit()
*+               Static Function WildReady()
*+               Function WildAdd()
*+               Function WildUpdate()
*+               Function WildDelete()
*+               Procedure WildClose()
*+               Function WildSeek()
*+
*+       Tables: use ( cFileName + '.WST' ) alias ( cAlias ) new exclusive
*+               use ( cFileName + '.WST' ) alias ( cAlias ) new shared
*+
*+      Indexes: index on field->word tag BYWORD to ( rootname( cFileName ) + '.WSX' )
*+               index on field->recno tag BYRECNO to ( rootname( cFileName ) + '.WSX' )
*+               index on field->word tag BYWORD to ( rootname( cFileName ) + '.WSX' )
*+               index on field->recno tag BYRECNO to ( rootname( cFileName ) + '.WSX' )
*+
*+    Reformatted by Click! 2.03 on Sep-8-1999 at  3:02 am
*+
*+

#include "COMMON.CH"
#include "SIXCDX.CH"

*+
*+
*+    Procedure Test()
*+
*+
*+
procedure Test( cSearchTerm )

local x
local aReturnData := {}
local aTestData   := { 'Gas Can, 2.5 Gallon', ;
                     '#10 washer and gasket', ;
                     '2" putty tube', ;
                     'Screen, faucet, 7/8"', ;
                     '2" gasket, Starite pump', ;
                     'Silicone putty', ;
                     'Plumbers putty', ;
                     '#2 FormAGasket', ;
                     'Don Gassee, Esq.', ;
                     'Benzine Gas' }

// first, initialize an empty setup for this build
wildinit( 'wildtest', 'wilddata' )

// Next, add each element to the wild seek table
for x := 1 to len( aTestData )
   wildadd( 'wildtest', aTestData[ x ], x )
next

// we opened in exclusive mode (for speed), so close it
wildclose( 'wildtest' )

default cSearchTerm to 'gas'

clear screen
?
? 'Search Term = ', cSearchTerm

?
? 'Match whole words only'
?
? '   Ordinal   Content'
?

aReturnData := wildseek( 'wildtest', 'wilddata', cSearchTerm, .t. )
for x := 1 to len( aReturnData )
   ? aReturnData[ x ], '|', aTestData[ aReturnData[ x ] ]
next

?
?
? 'Match partial words'
?
? '   Ordinal   Content'
?

aReturnData := wildseek( 'wildtest', 'wilddata', cSearchTerm, .f. )
for x := 1 to len( aReturnData )
   ? aReturnData[ x ], '|', aTestData[ aReturnData[ x ] ]
next

?
? 'Press any key for update process'

inkey( 0 )

aTestData[ 8 ] := '#2 Form A Gasket'

wildupdate( 'wildtest', 'wilddata', 8, aTestData[ 8 ] )

clear screen
?
? 'Search Term = ', cSearchTerm

?
? 'Match whole words only'
?
? '   Ordinal   Content'
?

aReturnData := wildseek( 'wildtest', 'wilddata', cSearchTerm, .t. )
for x := 1 to len( aReturnData )
   ? aReturnData[ x ], '|', aTestData[ aReturnData[ x ] ]
next

?
?
? 'Match partial words'
?
? '   Ordinal   Content'
?

aReturnData := wildseek( 'wildtest', 'wilddata', cSearchTerm, .f. )
for x := 1 to len( aReturnData )
   ? aReturnData[ x ], '|', aTestData[ aReturnData[ x ] ]
next

?
? 'Press any key for update process'

inkey( 0 )

aTestData[ 8 ] := '#2 Form A Gasket'

wilddelete( 'wildtest', 'wilddata', 5 )
aTestData[ 5 ] := ''

clear screen
?
? 'Search Term = ', cSearchTerm

?
? 'Match whole words only'
?
? '   Ordinal   Content'
?

altd()
aReturnData := wildseek( 'wildtest', 'wilddata', cSearchTerm, .t. )
for x := 1 to len( aReturnData )
   ? aReturnData[ x ], '|', aTestData[ aReturnData[ x ] ]
next

?
?
? 'Match partial words'
?
? '   Ordinal   Content'
?

aReturnData := wildseek( 'wildtest', 'wilddata', cSearchTerm, .f. )
for x := 1 to len( aReturnData )
   ? aReturnData[ x ], '|', aTestData[ aReturnData[ x ] ]
next

?
return

*+
*+
*+    Function WildInit()
*+
*+    Called from ( wildseek.prg )   1 - procedure test()
*+
*+
*+
function WildInit( cAlias, cFileName )

local lSuccess := .t.

cFileName := rootname( cFileName ) + '.WST'

/*
.WST = Wild Seek Table
.WSX = Wild Seek Index
*/

begin sequence

   dbcreate( CFILENAME , { { 'WORD',  'C', 10, 0 }, ;
                           { 'RECNO', 'N', 10, 0 } } )
   if neterr()
      lSuccess := .f.
      break
   endif

   ferase( rootname( cFileName ) + '.WSX' )

   if neterr()
      lSuccess := .f.
      break
   endif

   use ( cFileName ) alias ( cAlias ) new exclusive

   if neterr()
      lSuccess := .f.
      break
   endif

   index on field->word tag BYWORD to ( rootname( cFileName ) + '.WSX' )

   if neterr()
      lSuccess := .f.
      break
   endif

   index on field->recno tag BYRECNO to ( rootname( cFileName ) + '.WSX' )

   if neterr()
      lSuccess := .f.
      break
   endif

end sequence

return lSuccess

*+
*+
*+    Static Function WildReady()
*+
*+    Called from ( wildseek.prg )   1 - function wildupdate()
*+                                   1 - function wilddelete()
*+                                   1 - function wildseek()
*+
*+
*+
static function WildReady( cAlias, cFileName )

cFileName := rootname( cFileName )

if select( cAlias ) == 0

   use ( cFileName + '.WST' ) alias ( cAlias ) new shared

   if file( rootname( cFileName ) + '.WSX' )
      set index to ( rootname( cFileName ) + '.WSX' )
   else
      index on field->word tag BYWORD to ( rootname( cFileName ) + '.WSX' )
      index on field->recno tag BYRECNO to ( rootname( cFileName ) + '.WSX' )
   endif

endif

return select( cAlias ) > 0

*+
*+
*+    Function WildAdd()
*+
*+    Called from ( wildseek.prg )   1 - procedure test()
*+                                   1 - function wildupdate()
*+
*+
*+
function WildAdd( cAlias, cData, nRecno )

// assumes that WildInit() or WildReady() was already called

local nTokens  := numtoken( cData, ', ' )
local lSuccess := .t.
local x

if valtype( cData ) == 'C' .and. select( cAlias ) > 0
   if nTokens > 0
      ( cAlias )->( dbsetorder( 'BYRECNO' ) )
      for x := 1 to nTokens
         if ( cAlias )->( dbseek( 0 ) )
            ( cAlias )->( rlock() )
            ( cAlias )->( dbrecall() )
         else
            ( cAlias )->( dbappend() )
         endif
         ( cAlias )->word := upper( token( cData, ', ', x ) )
         ( cAlias )->recno := nRecno
         ( cAlias )->( dbcommit() )
         ( cAlias )->( dbunlock() )
      next
   endif
else
   lSuccess := .f.
endif

return lSuccess

*+
*+
*+    Function WildUpdate()
*+
*+    Called from ( wildseek.prg )   1 - procedure test()
*+
*+
*+
function WildUpdate( cAlias, cFileName, nRecno, cData )

local lSuccess

WildReady( cAlias, cFileName )

if ( lSuccess := WildDelete( cAlias, cFileName, nRecno ) )
   lSuccess := WildAdd( cAlias, cData, nRecno )
endif

return lSuccess

*+
*+
*+    Function WildDelete()
*+
*+
*+
function WildDelete( cAlias, cFileName, nRecno )

local lSuccess := .t.

WildReady( cAlias, cFileName )

begin sequence

   ( cAlias )->( dbsetorder( 'BYRECNO' ) )

   do while ( cAlias )->( dbseek( nRecno ) )
      if ( cAlias )->( rlock() )
         ( cAlias )->recno := 0
         ( cAlias )->( dbdelete() )
         ( cAlias )->( dbcommit() )
         ( cAlias )->( dbunlock() )
         ( cAlias )->( dbskip( 1 ) )
      else
         lSuccess := .f.
         break
      endif
   enddo

end sequence

return lSuccess

*+
*+
*+    Procedure WildClose()
*+
*+    Called from ( wildseek.prg )   1 - procedure test()
*+
*+
*+
procedure WildClose( cAlias )

if select( cAlias ) > 0
   ( cAlias )->( dbclosearea() )
endif

return

*+
*+
*+    Function WildSeek()
*+
*+    Called from ( wildseek.prg )   4 - procedure test()
*+
*+
*+
function WildSeek( cAlias, cFileName, cWildKey, lWholeWord )

local aData     := {}
local nElements := 0

default lWholeWord to .f.

WildReady( cAlias, cFileName )

cWildKey := upper( cWildKey )

( cAlias )->( dbsetorder( 'BYWORD' ) )
( cAlias )->( dbseek( cWildKey ) )

do while ( cAlias )->word = cWildKey .and. ( cAlias )->( !eof() )
   if !lWholeWord .or. alltrim( ( cAlias )->word ) == cWildKey
      if ( cAlias )->recno > 0
         aadd( aData, ( cAlias )->recno )
         if ++ nElements > 4090
            exit
         endif
      endif
   endif
   ( cAlias )->( dbskip( 1 ) )
enddo

return aData

*+ EOF: WILDSEEK.PRG
